/* cmd_neonspam_delbad.c - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonspam.h"

CMD_BIND(neonspam_cmd_delbad) {
    MYSQL_RES *res;
    MYSQL_ROW row;
    loadChannelSettings(chan);
    loadNeonSpamSettings(chan);
    struct NeonSpamSettings *settings = chan->spam_settings;
    if(!settings) return;
    int badword_id = atoi(argv[0]);
    printf_mysql_query("SELECT `badword_match` FROM `spamserv_badwords` WHERE `badword_id` = '%d' AND `badword_cid` = '%d'", badword_id, chan->channel_id);
    res = mysql_use();
    if(!(row = mysql_fetch_row(res))) {
        reply(textclient, user, "SS_BADWORD_ID_UNKNOWN", badword_id, chan->name);
        return;
    }
    struct NeonSpamBadword *badword, *prev = NULL;
    for(badword = settings->badwords; badword; badword = badword->next) {
        if(badword->id == badword_id) {
            if(prev)
                prev->next = badword->next;
            else
                settings->badwords = badword->next;
            free(badword->badword);
            free(badword);
            break;
        } else
            prev = badword;
    }
    printf_mysql_query("DELETE FROM `spamserv_badwords` WHERE `badword_id` = '%d'", badword_id);
    reply(textclient, user, "SS_BADWORD_DELETED", row[0], badword_id);
}
